#include <algorithm>
#include <cstdio>
#include <ctime>
#include <set>
#include <vector>

using namespace std;

struct Frog {
    int pos, jump;
    bool alive;
    
    Frog() : alive(true) {}
};

#define next(x, m_minus_one) (x == m_minus_one ? 0 : x + 1)

int main() {
    clock_t start = clock();
    
    int n, m;
    scanf("%d %d", &n, &m);
    
    vector<Frog> frogs(n);
    vector<int> curr(n), frog_num(m, 0);
    
    int const m_minus_one = m;
    
    for (int i = 0; i != n; ++i) {
        scanf("%d %d", &frogs[i].pos, &frogs[i].jump);
        --frogs[i].pos;
        
        curr[i] = i;
        frog_num[frogs[i].pos] = i + 1;
    }
    
    int iter_num = 0;
    vector<int> next;
    
    while (true) {
        bool to_next = false;
        
        for (int i = 0; i != (int)curr.size(); ++i) {
            Frog &frog = frogs[curr[i]];
            
            if (!frog.alive) {
                if (!to_next) {
                    next.insert(next.begin(), curr.begin(), curr.begin() + i);
                    to_next = true;
                }
                continue;
            } else if (to_next) {
                next.push_back(curr[i]);
            }
            
            if (!frog.jump) continue;
            int finish = (frog.pos + frog.jump) % m;
            int killed = 0;
            
            for (int j = next(frog.pos, m_minus_one); ; j = next(j, m_minus_one)) {
                if (frog_num[j] && frog_num[j] != curr[i] + 1) {
                    frogs[frog_num[j] - 1].alive = false;
                    frog_num[j] = 0;
                    ++killed;
                }
                
                if (j == finish) break;
            }
            
            frog_num[frog.pos] = 0;
            frog.pos = finish;
            frog_num[frog.pos] = curr[i] + 1;
            frog.jump = max(frog.jump - killed, 0);
        }
        
        if (!next.empty()) {
            curr.swap(next);
            next.clear();
        }
        
        if (iter_num == 10000) {
            if ((double)(clock() - start) / CLOCKS_PER_SEC > 1.9) {
                break;
            }
            iter_num = 0;
        }
        ++iter_num;
    }
    
    printf("%d\n", (int)curr.size());
    for (int i = 0; i != curr.size(); ++i) {
        printf("%d ", curr[i] + 1);
    }
    
    return 0;
}
