def find_symmetric_decomposition_brute_force_half(n, summand_len):
    n = int(n)
    
    if summand_len == 0 or n <= 10 ** (summand_len - 1):
        return ""
        
    best_difference = n
    result = -1
    half_size_up = (summand_len + 1) // 2
    half_size_down = summand_len // 2
    for summand_half in range(10 ** half_size_up):
        summand = (str(n - summand_half)[-1 : -half_size_down - 1 : -1] + 
                   str(summand_half).zfill(half_size_up))
        summand_reverse = summand[::-1]
        
        if summand_reverse[0] == '0' and summand[0] == '0':
            continue
        
        summand = int(summand)        
        summand_reverse = int(summand_reverse)
        if summand + summand_reverse == n:
            max_summand = max(summand, summand_reverse)
            min_summand = min(summand, summand_reverse)
            if (max_summand - min_summand < best_difference):
                best_difference = max_summand - min_summand
                result = max_summand
    return str(result) if result != -1 else ""

def find_symmetric_decomposition(n):
    answer1 = find_symmetric_decomposition_brute_force_half(n, len(n) - 1)
    answer2 = find_symmetric_decomposition_brute_force_half(n, len(n))
    if answer1 == "" and answer2 == "":
        return "0"
    
    diff1 = int(n)
    diff2 = int(n)
    if answer1 != "":
        diff1 = int(answer1) - int(answer1[::-1])
    if answer2 != "":
        diff2 = int(answer2) - int(answer2[::-1])
    return answer1 if diff1 < diff2 else answer2
    
print(find_symmetric_decomposition(input()))
